function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

export var FetchCache =
/*#__PURE__*/
function () {
  function FetchCache(state) {
    this.state = state;
  }

  var _proto = FetchCache.prototype;

  _proto.set = function set(action, value) {
    var item = _extends({}, value, {
      action: action,
      cachedAt: Date.now()
    });

    this.state[action.id] = item;
  };

  _proto.updateValue = function updateValue(actionId, data) {
    if (this.state[actionId]) {
      this.state[actionId].data = data;
    } else {
      this.state[actionId] = {
        data: data,
        cachedAt: Date.now()
      };
    }
  };

  _proto.get = function get(id) {
    return this.state[id];
  };

  _proto.remove = function remove(id) {
    var _this$state = this.state,
        deleted = _this$state[id],
        nextState = _objectWithoutPropertiesLoose(_this$state, [id].map(_toPropertyKey));

    this.state = nextState;
  };

  _proto.getState = function getState() {
    return this.state;
  };

  _proto.setState = function setState(state) {
    this.state = state;
  };

  return FetchCache;
}();
export var createCache = function createCache(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      initialState = _ref.initialState;

  return new FetchCache(initialState || {});
};