import { useEffect, useMemo, useCallback, useState } from 'react';
import { useFetchClient } from './use-fetch-client';
import { actHack } from './act-hack';
export var useFetchCache = function useFetchCache(actionId) {
  var client = useFetchClient();

  var _useState = useState(client.cache.get(actionId)),
      value = _useState[0],
      setValue = _useState[1];

  useEffect(function () {
    return client.listen(actionId, {
      update: function update(newValue) {
        actHack(function () {
          return setValue(newValue);
        });
      }
    });
  }, [client, actionId, setValue]);
  var updateCacheValue = useCallback(function (newValue) {
    return client.mutate(actionId, newValue);
  }, [client]);
  return useMemo(function () {
    return [value, updateCacheValue];
  }, [client, value]);
};