function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { useCallback, useMemo, useState } from 'react';
import { actHack } from './act-hack';
import { useFetchClient } from './use-fetch-client';
export default function useFetchMutation(actionCreator) {
  var client = useFetchClient();

  var _useState = useState({
    loading: false
  }),
      state = _useState[0],
      setState = _useState[1];

  var mutate = useCallback(function (arg) {
    try {
      var action = actionCreator(arg);

      if (action === null) {
        return;
      }

      actHack(function () {
        return setState({
          loading: true
        });
      });
      return client.dispatch(action)["catch"](function (error) {
        actHack(function () {
          setState({
            error: error,
            action: action,
            loading: false
          });
        });
        throw error;
      }).then(function (result) {
        actHack(function () {
          setState(_extends({}, result, {
            action: action,
            loading: false
          }));
        });

        if (result.error) {
          throw result.error;
        }

        return result.data;
      });
    } catch (error) {
      actHack(function () {
        setState({
          error: error,
          loading: false
        });
      });
      return error;
    }
  }, [actionCreator]);
  var result = useMemo(function () {
    return _extends({}, state, {
      mutate: mutate,
      reset: function reset() {
        return setState({
          loading: false
        });
      }
    });
  }, [state, mutate]);
  return result;
}