export interface FetchAction<TMeta = any> extends RequestInit {
    id?: string;
    method: string;
    url: string;
    meta?: TMeta;
    ssr?: boolean;
}
export interface DispatchedFetchAction<TMeta = any> extends Omit<FetchAction<TMeta>, 'id'> {
    id: string;
}
export interface FetchActionCreator<TArg = any, TMeta = any> {
    (arg?: TArg): FetchAction<TMeta> | null;
}
