import { DispatchedFetchAction } from './action';
import { FetchQueryResult } from './use-fetch';
export interface CacheItem<TData, TMeta> extends Omit<FetchQueryResult<TData, TMeta>, 'loading'> {
    cachedAt: number;
}
export interface CacheState {
    [key: string]: CacheItem<any, any>;
}
export declare class FetchCache {
    protected state: CacheState;
    constructor(state: CacheState);
    set<TData, TMeta, TAction extends DispatchedFetchAction<TMeta>>(action: TAction, value: TData): void;
    updateValue<TData>(actionId: string, data: TData): void;
    get<TData, TMeta>(id: string): CacheItem<TData, TMeta> | undefined;
    remove(id: string): void;
    getState(): CacheState;
    setState(state: CacheState): void;
}
interface CreateCacheConfig {
    initialState?: CacheState;
}
export declare const createCache: ({ initialState, }?: CreateCacheConfig) => FetchCache;
export {};
