"use strict";

exports.__esModule = true;
exports.useFetchCache = void 0;

var _react = require("react");

var _useFetchClient = require("./use-fetch-client");

var _actHack = require("./act-hack");

var useFetchCache = function useFetchCache(actionId) {
  var client = (0, _useFetchClient.useFetchClient)();

  var _useState = (0, _react.useState)(client.cache.get(actionId)),
      value = _useState[0],
      setValue = _useState[1];

  (0, _react.useEffect)(function () {
    return client.listen(actionId, {
      update: function update(newValue) {
        (0, _actHack.actHack)(function () {
          return setValue(newValue);
        });
      }
    });
  }, [client, actionId, setValue]);
  var updateCacheValue = (0, _react.useCallback)(function (newValue) {
    return client.mutate(actionId, newValue);
  }, [client]);
  return (0, _react.useMemo)(function () {
    return [value, updateCacheValue];
  }, [client, value]);
};

exports.useFetchCache = useFetchCache;