"use strict";

exports.__esModule = true;
exports["default"] = useFetchMutation;

var _react = require("react");

var _actHack = require("./act-hack");

var _useFetchClient = require("./use-fetch-client");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function useFetchMutation(actionCreator) {
  var client = (0, _useFetchClient.useFetchClient)();

  var _useState = (0, _react.useState)({
    loading: false
  }),
      state = _useState[0],
      setState = _useState[1];

  var mutate = (0, _react.useCallback)(function (arg) {
    try {
      var action = actionCreator(arg);

      if (action === null) {
        return;
      }

      (0, _actHack.actHack)(function () {
        return setState({
          loading: true
        });
      });
      return client.dispatch(action)["catch"](function (error) {
        (0, _actHack.actHack)(function () {
          setState({
            error: error,
            action: action,
            loading: false
          });
        });
        throw error;
      }).then(function (result) {
        (0, _actHack.actHack)(function () {
          setState(_extends({}, result, {
            action: action,
            loading: false
          }));
        });

        if (result.error) {
          throw result.error;
        }

        return result.data;
      });
    } catch (error) {
      (0, _actHack.actHack)(function () {
        setState({
          error: error,
          loading: false
        });
      });
      return error;
    }
  }, [actionCreator]);
  var result = (0, _react.useMemo)(function () {
    return _extends({}, state, {
      mutate: mutate,
      reset: function reset() {
        return setState({
          loading: false
        });
      }
    });
  }, [state, mutate]);
  return result;
}