import { FetchAction } from './action';
export interface FetchMorePlan<Payload, NextPayload> extends RequestInit {
    url: string;
    updateData: (nextData: NextPayload, prevData: Payload) => Payload;
}
export interface FetchQueryResult<TData, TMeta = any> {
    status?: number;
    error?: Error;
    data?: TData;
    headers?: Headers;
    loading: boolean;
    action?: FetchAction<TMeta>;
}
interface Helpers<Payload> {
    fetchMore: <NextPayload = Payload>(fn: (currentResult: FetchHookResultBase<Payload>) => FetchMorePlan<Payload, NextPayload> | void) => void;
}
export declare type FetchHookResultBase<Payload> = {
    readonly data: Payload;
    readonly loading: boolean;
    readonly error: undefined;
} | {
    readonly data: undefined;
    readonly loading: boolean;
    readonly error: Error;
} | {
    readonly data: undefined;
    readonly loading: boolean;
    readonly error: undefined;
};
export declare type FetchHookResult<Payload> = FetchHookResultBase<Payload> & Helpers<Payload>;
export declare type UseFetchOptions = RequestInit & {
    ssr?: boolean;
    skip?: boolean;
    stackSize?: number;
};
export default function useFetch<TData, TMeta = any>(action: FetchAction<TMeta> | null): FetchQueryResult<TData, TMeta>;
export {};
